const CI = Components.interfaces;
const CC = Components.classes;
function addAutopagerButton() {
    var toolbox = document.getElementById("navigator-toolbox");
    var toolboxDocument = toolbox.ownerDocument;
    
    var hasAutopagerButton = false;
    for (var i = 0; i < toolbox.childNodes.length; ++i) {
        var toolbar = toolbox.childNodes[i];
        if (toolbar.localName == "toolbar" && toolbar.getAttribute("customizable") == "true") {
            if (toolbar.currentSet.indexOf("autopager-button") > -1) {
                hasAutopagerButton = true;
            }
        }
    }
    
    if(!hasAutopagerButton) {
        for (var i = 0; i < toolbox.childNodes.length; ++i) {
            toolbar = toolbox.childNodes[i];
            if (toolbar.localName == "toolbar" &&  toolbar.getAttribute("customizable") == "true" && toolbar.id == "nav-bar") {
                var newSet = "";
                var child = toolbar.firstChild;
                while (child) {
                    if(!hasAutopagerButton && child.id == "urlbar-container") {
                        newSet += "autopager-button,";
                        hasAutopagerButton = true;
                    }
                    newSet += child.id + ",";
                    child = child.nextSibling;
                }
                newSet = newSet.substring(0, newSet.length - 1);
                toolbar.currentSet = newSet;
                toolbar.setAttribute("currentset", newSet);
                toolboxDocument.persist(toolbar.id, "currentset");
                try {
                    BrowserToolboxCustomizeDone(true);
                } catch (e) {}
                break;
            }
        }
    }
}

function autopagerToobarInit() {
    var autopagerHome = "http://autopager.teesoft.info";
    var localstore = RDF.GetDataSource("rdf:local-store");
    var prefService = Components.classes["@mozilla.org/preferences;1"].getService(Components.interfaces.nsIPrefService);
    var prefBranch = prefService.getBranch("autopager.");
    if (!prefBranch.prefHasUserValue("last_version")) {  // new user
        addAutopagerButton();
        autopagerOpenIntab(autopagerHome);
        prefBranch.setCharPref("last_version", "0.1.6.0.0");
    } else { // check for upgrade
        var lastVersion = prefBranch.getCharPref("last_version");
        if (lastVersion != "0.1.6.0.0")
        {
            //addAutopagerButton();
            autopagerOpenIntab(autopagerHome);
            prefBranch.setCharPref("last_version", "0.1.6.0.0");
        }
    }
}

function autopagerOpenIntab(url)
{
    var wm =  CC['@mozilla.org/appshell/window-mediator;1'].getService(CI.nsIWindowMediator);
    var w = wm && wm.getMostRecentWindow('navigator:browser', true);
    if(w && !w.closed) {
        var browser = w.getBrowser();
        browser.selectedTab = browser.addTab(url, null);
    } else {
        window.open(url, "_blank")
    }        
}

window.addEventListener("load", function() { setTimeout(autopagerToobarInit, 250); }, false);
